
stages:
  - build
  - test
  - package
  - deploy


build:
  stage: build
  image: docker:20
  services:
    - docker:dind
  script:
    - docker build -t calculator_rest_mqtt .
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker tag calculator_rest_mqtt $CI_REGISTRY_IMAGE/calculator_rest_mqtt
    - docker push $CI_REGISTRY_IMAGE/calculator_rest_mqtt
 
test:
  stage: test
  image: node:14-alpine
  script:
    - npm install
    - npm run test
    
coverage:
  stage: test
  image: node:14-alpine
  script:
    - mkdir coverage
    - npm install
    - npm run coverage
  artifacts:
    paths:
      - coverage/


package:
  stage: package
  image: node:14-alpine
  script:
    - npm install
    - npm pack


  artifacts:
    paths:
      - "*.tgz"


deploy:
  stage: deploy
  image: docker:20
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE/calculator_rest_mqtt
    - docker run -d -p 8080:8080 $CI_REGISTRY_IMAGE/calculator_rest_mqtt
